clear all
close all

filename = { ...
    '4015.txt' % Subj01
    '4021.txt' % Subj02
    '4013.txt' % Subj03
    '4025.txt' % Subj04
    '4018.txt' % Subj05
    };
savePath = './';
%fname = 'objectsTag_true_HD';
%fname = 'objectsTag_truetag_HD';
fname = 'objectsTag_truetag_fix_HD';
%fname = 'objectsTag_true_probAO_HD';
tolerance = 70; %pixel, for eye only



%%% Load eye pos
loadPath = '../';
load([loadPath 'vg3_HDB_fix.mat'],'eyepos','hand'); %% eyepos = [x y], hand = [x y lb mb rb]

% Caution: Box should be set for each game separately
box = [37 15 583 438]; nativeRes=[1024 768];


for subjNo = 1:5
    
    fprintf('Subj%d-',subjNo); tic;
    
    fid = fopen(filename{subjNo});
    x = textscan(fid, '%d%s%d%d%s%d%d%d%s%d%s','headerlines',1,'delimiter','|');
    fclose(fid);
    
    %%% line list:
    %  1=obj (?)
    %  2=name (?)
    %  3=type (?)
    %  4=type (?)
    %  5=value (object names)
    %  6=category (?)
    %  7=scene (?)
    %  8=frame
    %  9=vertices/polygons
    % 10=confidence (?)
    % 11=name of the file
    
    
    %%% Parsing the polygons
    myPoly = x{9}; % the polygons
    allPoly = cell(length(myPoly),1);
    %polyX = cell(length(myPoly),1); polyY = cell(length(myPoly),1);
    boundingBox = zeros(length(myPoly),4); %%% we do [x y w h] here
    for i=1:length(myPoly)
        a=textscan(myPoly{i},'%f','delimiter','(),');
        a = a{1}; % to remove cell
        tmp = a(~isnan(a)); % just the non-NaNs
        allPoly{i}=tmp;
        %polyX{i} = tmp(1:2:end);
        %polyY{i} = tmp(2:2:end);
        
        % format: [x1 y1 x2 y2]
        bx = min(tmp(1:2:end));
        by = min(tmp(2:2:end));
        bw = max(tmp(1:2:end)) - bx;
        bh = max(tmp(2:2:end)) - by;

        % format: [x y w h]
        %bx = mean([max(tmp(1:2:end)) min(tmp(1:2:end))]);
        %by = mean([max(tmp(2:2:end)) min(tmp(2:2:end))]);
        %bw = (max(tmp(1:2:end)) - bx)*2;
        %bh = (max(tmp(2:2:end)) - by)*2;
        
        boundingBox(i,:) = [bx by bw bh];
    end
    x{9} = allPoly;
    
    %%% Check names
    allNames = x{5};
    objNames = unique(allNames);
    objNo = length(objNames);
    
    %%%%% Retrieving the parsed data
    oldMouseClick = 16;
    objectsTag = zeros(9000, 12);
    probAO = zeros(9000, 16); %%% only 15 since 16=empty, but make 16 to be consistent
    myTagData = cell(9000,1);
    objectNumber = { ...
        'orderhotdogketchup'
        'orderhotdog'
        'orderdrink'
        'ketchup'
        'money'
        'trash'
        'bread'
        'hotdog'
        'hotdogketchup'
        'sausagecooked'
        'sausageraw'
        'sausageburn'
        'drinkpool'
        'breadpool'
        'hotdogpool'
        };
    fprintf('[');
    for frameNo = 1:9000
        if (mod(frameNo,1000)==0); fprintf('.'); end
        idx = find(x{8} == frameNo);
        if isempty(idx); continue;end %%% Hey, no objects, skip this
        
        %%% Tag
        theTagData = [];
        for i=1:length(idx)
            myBox=boundingBox(idx(i),:);
            if myBox(3) < 80
                diff = 50-myBox(3);
                myBox(3) = 80;
                myBox(1) = max(myBox(1) - diff/2,1);
            end
            if myBox(1)+myBox(3) > 640
                myBox(3) = 640 - myBox(1);
            end
            if myBox(4) < 80
                diff = 50-myBox(4);
                myBox(4) = 80;
                myBox(2) = max(myBox(2) - diff/2,1);
            end
            if myBox(2)+myBox(4) > 480
                myBox(4) = 480 - myBox(2);
            end
            theTagData = [theTagData; x{5}(idx(i)) myBox];
%             aaa=objects{i}{3};
%             
%             for j=1:length(coordinates{i})
%                 bbb=[coordinates{i}{j}(1)-aaa(3)/2 coordinates{i}{j}(2)-aaa(4)/2 aaa(3) aaa(4)];
%                 if j==5 %Money
%                     bbb = [coordinates{i}{j}(1)-aaa(3)/2 175 aaa(3) 44];
%                 end
%                 if labels{i}(j) ~= -1%inside rectangle is not empty
%                     theTagData = [theTagData; {objects{labels{i}(j)}{1} bbb}];
%                 end
%             end
        end
        myTagData{frameNo} = theTagData;
        
        %%% AO
        objectsTag(frameNo,1) = sum(strcmp(x{5}(idx),'bread')) + 1; %bread
        objectsTag(frameNo,2) = sum(strcmp(x{5}(idx),'hotdog')) + 1; %hotdog
        objectsTag(frameNo,3) = sum(strcmp(x{5}(idx),'hotdogketchup')) + 1; %HDK
        
        objectsTag(frameNo,4) = sum(strcmp(x{5}(idx),'sausageraw')) + 1; %Saug Raw
        objectsTag(frameNo,5) = sum(strcmp(x{5}(idx),'sausagecooked')) + 1; %Saug Coo
        objectsTag(frameNo,6) = sum(strcmp(x{5}(idx),'sausageburn')) + 1; %Saug Bur
        
        objectsTag(frameNo,7) = sum(strcmp(x{5}(idx),'orderhotdog')) + 1; %Ord HDO
        objectsTag(frameNo,8) = sum(strcmp(x{5}(idx),'orderhotdogketchup')) + 1; %Ord HDK
        objectsTag(frameNo,9) = sum(strcmp(x{5}(idx),'orderdrink')) + 1; %Ord DRK
        
        objectsTag(frameNo,10) = sum(strcmp(x{5}(idx),'money')) + 1; % Moneh
        
        %%% Attended Object (AO)
        xs = eyepos{subjNo}(frameNo,1);
        ys = eyepos{subjNo}(frameNo,2);
        
        % Find the nearest object to eye position
        combiName=x{5}(idx);
        combi = [xs ys ; boundingBox(idx,1:2)];
        just = boundingBox(idx,:);
        distance = pdist(combi);
        distance = distance(1:length(idx));
        [minDist sortIdx] = sort(distance); % Okay, closest object is in sortIdx(1)
        
        %%% Build a probability table here
        %probAO
        alpha = 1; % for distance measure
        tmpAO = zeros(1,16);
        for zzz=1:length(sortIdx)
            nearIdx = sortIdx(zzz);
            number = find(strcmp(combiName{nearIdx},objectNumber));
            dist = minDist(zzz)/10;%/sum(minDist);
            tmpAO(number) = 1/exp(alpha*dist); %%% Exponential
            %tmpAO(number) = 1/dist; %%% Linear
        end
        tmpAO = tmpAO / sum(tmpAO); % make into probability that sums to 1
        probAO(frameNo,:) = tmpAO;
        
        
        % Check whether its valid inside box or not
        oldNumber = 16;
        for zzz=1:length(sortIdx)
            nearIdx = sortIdx(zzz);
            if (xs < just(nearIdx,1)+(just(nearIdx,3)/2)+tolerance && ...
                    xs > just(nearIdx,1)-(just(nearIdx,3)/2)-tolerance && ...
                    ys < just(nearIdx,2)+(just(nearIdx,4)/2)+tolerance && ...
                    ys > just(nearIdx,2)-(just(nearIdx,4)/2)-tolerance)
                
                number = find(strcmp(combiName{nearIdx},objectNumber));
                if isempty(number); number = 16; continue; end;
                if number > 12; oldNumber = number; number=16; continue; end; % low priority
                if number == 6; oldNumber = number; number=16; continue; end; % low priority
                objectsTag(frameNo,11) = number;
                break;
            else
                objectsTag(frameNo,11) = 16;
            end
        end
        if oldNumber~=16 && number==16
            objectsTag(frameNo,11) = oldNumber;
        end
        
        %%% Clicked Object (CO)
        hxs = hand{subjNo}(frameNo,1);
        hys = hand{subjNo}(frameNo,2);
        
        hxs = hxs * box(3)/nativeRes(1) + box(1);
        hys = hys * box(4)/nativeRes(2) + box(2);
        hbs = hand{subjNo}(frameNo,3); % mouse - L button
        
        combi = [hxs hys ; boundingBox(idx,1:2)];
        distance = pdist(combi);
        distance = distance(1:length(idx));
        [a sortIdx] = sort(distance); % Okay, closest object is in sortIdx(1)
        % Check whether its valid inside box or not
        
        
        if hbs == 1
            for zzz=1:length(sortIdx)
                nearIdx = sortIdx(zzz);
                if (hxs < just(nearIdx,1)+(just(nearIdx,3)/2) && ...
                        hxs > just(nearIdx,1)-(just(nearIdx,3)/2) && ...
                        hys < just(nearIdx,2)+(just(nearIdx,4)/2) && ...
                        hys > just(nearIdx,2)-(just(nearIdx,4)/2))
                    
                    number = find(strcmp(combiName{nearIdx},objectNumber));
                    if isempty(number); number = 16; continue; end;
                    if number <= 3; number = 16; end % Orders
                    if number == 5; number = 16; end % Money
                    if number == 6; number = 16; end % Trash
                    if number >=13; number = 16; end % Pools
                    objectsTag(frameNo,12) = number;
                    oldMouseClick = number;
                    break;
                else
                    objectsTag(frameNo,12) = 16;
                    oldMouseClick = 16;
                end
            end
        else
            objectsTag(frameNo,12) = oldMouseClick;
        end
    end % FrameNo
    fprintf(']');
    
    %save([savePath fname int2str(subjNo) '.mat'], 'objectsTag');
    save([savePath fname int2str(subjNo) '.mat'], 'myTagData');
    %save([savePath fname int2str(subjNo) '.mat'], 'probAO');
    toc
end